package com.ims.eval.service.custom;


import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.ims.eval.config.ImaConfig;
import com.ims.eval.entity.dto.result.ResultInfo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.*;
import org.springframework.stereotype.Service;
import org.springframework.util.LinkedMultiValueMap;
import org.springframework.util.MultiValueMap;
import org.springframework.web.client.RestTemplate;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

@Service
@Slf4j
public class PostUserService {

	@Autowired
	private RestTemplate restTemplate;


	@Autowired
	private ImaConfig imaConfig;


	public Object getPostUserList(Integer current, Integer size, String posId, HttpServletRequest request) {
		HttpHeaders headers = new HttpHeaders();
		headers.setContentType(MediaType.APPLICATION_JSON_UTF8);
		headers.add("Blade-Auth", "bearer " + request.getHeader("Blade-Auth"));
		HttpEntity<Map> param = new HttpEntity<>(null, headers);
		ResponseEntity<String> responseEntity2 = restTemplate.exchange(imaConfig.getGatewayUrl() + "/ims-idms/pgposuser/page?current={1}&size={2}&posId={3}", HttpMethod.GET, param, String.class, current, size, posId);
		log.info("\n code:{}\n header:{}\n body:{}\n", responseEntity2.getStatusCodeValue(), responseEntity2.getHeaders(), responseEntity2.getBody());
		if (200 == responseEntity2.getStatusCodeValue()) {
			ResultInfo resultInfo = JSON.parseObject(responseEntity2.getBody(), ResultInfo.class);
			if (200 == resultInfo.getCode()) {
				return resultInfo.getData();
			}
			return null;
		}
		return null;
	}


	public Object getUserPostList(Integer current, Integer size, String userId, HttpServletRequest request) {
		HttpHeaders headers = new HttpHeaders();
		headers.setContentType(MediaType.APPLICATION_JSON_UTF8);
		headers.add("Blade-Auth", "bearer " + request.getHeader("Blade-Auth"));
		HttpEntity<Map> param = new HttpEntity<>(null, headers);
		ResponseEntity<String> responseEntity2 = restTemplate.exchange(imaConfig.getGatewayUrl() + "/ims-idms/pgposuser/page?current={1}&size={2}&userId={3}", HttpMethod.GET, param, String.class, current, size, userId);
		log.info("\n code:{}\n header:{}\n body:{}\n", responseEntity2.getStatusCodeValue(), responseEntity2.getHeaders(), responseEntity2.getBody());
		if (200 == responseEntity2.getStatusCodeValue()) {
			ResultInfo resultInfo = JSON.parseObject(responseEntity2.getBody(), ResultInfo.class);
			if (200 == resultInfo.getCode()) {
				return resultInfo.getData();
			}
			return null;
		}
		return null;
	}

	public String getBbUserPostList(Integer pageIndex, Integer pageSize, String baseFilter, HttpServletRequest request) {
		HttpHeaders headers = new HttpHeaders();
		headers.setContentType(MediaType.APPLICATION_JSON_UTF8);
		headers.add("Blade-Auth", "bearer " + request.getHeader("Blade-Auth"));
		HttpEntity<Map> param = new HttpEntity<>(null, headers);
		String baseFilterStr = "((o.id ='" + baseFilter + "') or (o.parent_ids like '%,%" + baseFilter + ",%'))";
		ResponseEntity<String> responseEntity2 = restTemplate.exchange(imaConfig.getGatewayUrl() + "/ims-iam-ext/sys/sysUser/misData?pageIndex={1}&pageSize={2}&baseFilter={3}", HttpMethod.POST, param, String.class, pageIndex, pageSize, baseFilterStr);
		log.info("\n code:{}\n header:{}\n body:{}\n", responseEntity2.getStatusCodeValue(), responseEntity2.getHeaders(), responseEntity2.getBody());
		if (200 == responseEntity2.getStatusCodeValue()) {
			return responseEntity2.getBody();
		}
		return null;
	}



	public JSONObject getSysUser(String code,String bladeAuth, HttpServletRequest request) {

		System.out.println("请求-6-获取用户信息");
		MultiValueMap<String, String> headers = new LinkedMultiValueMap<>();
		headers.add("Blade-Auth", "bearer " +bladeAuth);
		HttpEntity<LinkedMultiValueMap<String, Object>> param = new HttpEntity<>(null, headers);

		ResponseEntity<String> responseEntity2 = restTemplate.postForEntity(imaConfig.getGatewayUrl() + "/ims-idms/sysuser/getSysUser?code={code}",
			param, String.class, code);
		log.info("\n code:{}\n header:{}\n body:{}\n", responseEntity2.getStatusCodeValue(), responseEntity2.getHeaders(), responseEntity2.getBody());
		if (200 == responseEntity2.getStatusCodeValue()) {
			return JSON.parseObject(responseEntity2.getBody());
		}
		return null;
	}


}
